diff --git a/ldap/admin/src/scripts/FileConn.pm b/ldap/admin/src/scripts/FileConn.pm
index fe5acb5..bead2a4 100644
--- a/ldap/admin/src/scripts/FileConn.pm
+++ b/ldap/admin/src/scripts/FileConn.pm
@@ -63,8 +63,8 @@ sub new {
     $self = bless $self, $class;
 
     $self->{readonly} = $readonly;
-    for (@namingContexts) {
-        $self->setNamingContext($_);
+    for my $ctx (@namingContexts) {
+        $self->setNamingContext($ctx);
     }
     $self->setNamingContext(""); # root DSE
     if (!$self->read($filename)) {
@@ -192,9 +192,9 @@ sub write {
     }
 
     $self->iterate("", LDAP_SCOPE_SUBTREE, \&writecb, \*MYLDIF);
-    for (keys %{$self->{namingContexts}}) {
-        next if (!$_); # skip "" - we already did that
-        $self->iterate($_, LDAP_SCOPE_SUBTREE, \&writecb, \*MYLDIF);
+    for my $ctx (keys %{$self->{namingContexts}}) {
+        next if (!$ctx); # skip "" - we already did that
+        $self->iterate($ctx, LDAP_SCOPE_SUBTREE, \&writecb, \*MYLDIF);
     }
     close( MYLDIF );
 
@@ -354,12 +354,12 @@ sub cloneEntry {
     }
     my $dest = new Mozilla::LDAP::Entry();
     $dest->setDN($src->getDN());
-    for (keys %{$src}) {
-        if (ref($src->{$_})) {
-            my @copyary = @{$src->{$_}};
-            $dest->{$_} = [ @copyary ]; # make a deep copy
+    for my $key (keys %{$src}) {
+        if (ref($src->{$key})) {
+            my @copyary = @{$src->{$key}};
+            $dest->{$key} = [ @copyary ]; # make a deep copy
         } else {
-            $dest->{$_} = $src->{$_};
+            $dest->{$key} = $src->{$key};
         }
     }
 
diff --git a/ldap/admin/src/scripts/Inf.pm b/ldap/admin/src/scripts/Inf.pm
index 091940b..bb22913 100644
--- a/ldap/admin/src/scripts/Inf.pm
+++ b/ldap/admin/src/scripts/Inf.pm
@@ -88,31 +88,32 @@ sub read {
         }
         $inffh = \*INF;
     }
-    while (<$inffh>) {
+    my $line;
+    while ($line = <$inffh>) {
         my $iscontinuation;
-        chop; # trim trailing newline
-        if (/^\s*$/) { # skip blank/empty lines
+        chop $line; # trim trailing newline
+        if ($line =~ /^\s*$/) { # skip blank/empty lines
             $incontinuation = 0;
             next;
         }
-        if (/^\s*\#/) { # skip comment lines
+        if ($line =~ /^\s*\#/) { # skip comment lines
             $incontinuation = 0;
             next;
         }
-        if (/\\$/) { # line ends in \ - continued on next line
-            chop;
+        if ($line =~ /\\$/) { # line ends in \ - continued on next line
+            chop $line;
             $iscontinuation = 1;
         }
         if ($incontinuation) {
             if ($curval) {
-                $self->{$curSection}->{$curkey}->[$curval] .= "\n" . $_; # add line in entirety to current value
+                $self->{$curSection}->{$curkey}->[$curval] .= "\n" . $line; # add line in entirety to current value
             } else {
-                $self->{$curSection}->{$curkey} .= "\n" . $_; # add line in entirety to current value
+                $self->{$curSection}->{$curkey} .= "\n" . $line; # add line in entirety to current value
             }
-        } elsif (/^\[(.*?)\]/) { # e.g. [General]
+        } elsif ($line =~ /^\[(.*?)\]/) { # e.g. [General]
             $curSection = $1;
             $iscontinuation = 0; # disallow section continuations
-        } elsif (/^\s*(.*?)\s*=\s*(.*?)\s*$/) { # key = value
+        } elsif ($line =~ /^\s*(.*?)\s*=\s*(.*?)\s*$/) { # key = value
             $curkey = $1;
             # a single value is just a single scalar
             # multiple values are represented by an array ref
@@ -207,8 +208,8 @@ sub updateFromArgs {
     }
 
     # read args into temp inf
-    for (@_) {
-        if (/^([\w_-]+)\.([\w_-]+)=(.*)$/) { # e.g. section.param=value
+    for my $arg (@_) {
+        if ($arg =~ /^([\w_-]+)\.([\w_-]+)=(.*)$/) { # e.g. section.param=value
             my $sec = $1;
             my $parm = $2;
             my $val = $3;
@@ -227,7 +228,7 @@ sub updateFromArgs {
                 $argsinf->{$sec}->{$parm} = $val;
             }
         } else { # error
-            print STDERR "Error: unknown command line option $_\n";
+            print STDERR "Error: unknown command line option $arg\n";
             return;
         }
     }
diff --git a/ldap/admin/src/scripts/Resource.pm b/ldap/admin/src/scripts/Resource.pm
index 1fcd44c..911ab08 100644
--- a/ldap/admin/src/scripts/Resource.pm
+++ b/ldap/admin/src/scripts/Resource.pm
@@ -77,27 +77,28 @@ sub read {
         my $incontinuation = 0;
         my $curkey;
         open RES, $filename or die "Error: could not open resource file $filename: $!";
-        while (<RES>) {
+        my $line;
+        while ($line = <RES>) {
             my $iscontinuation;
-            chop; # trim trailing newline
-            if (/^\s*$/) { # skip blank/empty lines
+            chop $line; # trim trailing newline
+            if ($line =~ /^\s*$/) { # skip blank/empty lines
                 $incontinuation = 0;
                 next;
             }
-            if (/^\s*\#/) { # skip comment lines
+            if ($line =~ /^\s*\#/) { # skip comment lines
                 $incontinuation = 0;
                 next;
             }
             # read name = value pairs like this
             # bol whitespace* name whitespace* '=' whitespace* value eol
             # the value will include any trailing whitespace
-            if (/\\$/) {
-                chop;
+            if ($line =~ /\\$/) {
+                chop $line;
                 $iscontinuation = 1;
             }
             if ($incontinuation) {
-                $self->{res}->{$curkey} .= "\n" . $_;
-            } elsif (/^\s*(.*?)\s*=\s*(.*?)$/) {
+                $self->{res}->{$curkey} .= "\n" . $line;
+            } elsif ($line =~ /^\s*(.*?)\s*=\s*(.*?)$/) {
                 # replace \n with real newline
                 if ($curkey) {
                     $self->{res}->{$curkey} =~ s/\\n/\n/g;
diff --git a/ldap/admin/src/scripts/Util.pm.in b/ldap/admin/src/scripts/Util.pm.in
index 6d54648..29f268f 100644
--- a/ldap/admin/src/scripts/Util.pm.in
+++ b/ldap/admin/src/scripts/Util.pm.in
@@ -46,11 +46,11 @@ use Mozilla::LDAP::LDIF;
 require Exporter;
 @ISA       = qw(Exporter);
 @EXPORT    = qw(portAvailable getAvailablePort isValidDN addSuffix getMappedEntries
-                process_maptbl check_and_add_entry getMappedEntries
+                process_maptbl check_and_add_entry getMappedEntries addErr
                 getHashedPassword debug createInfFromConfig shellEscape
                 isValidServerID isValidUser makePaths getLogin remove_tree remove_pidfile);
 @EXPORT_OK = qw(portAvailable getAvailablePort isValidDN addSuffix getMappedEntries
-                process_maptbl check_and_add_entry getMappedEntries
+                process_maptbl check_and_add_entry getMappedEntries addErr
                 getHashedPassword debug createInfFromConfig shellEscape
                 isValidServerID isValidUser makePaths getLogin remove_tree remove_pidfile);
 
@@ -658,7 +658,7 @@ sub process_maptbl
                 }
                 else
                 {
-                    push @{$errs}, 'no_mapvalue_for_key', $value, $key;
+                    push @{$errs}, ['no_mapvalue_for_key', $value, $key];
                     return {};
                 }
             }
@@ -813,21 +813,21 @@ sub makePaths {
          $parent = dirname($parent)) {
         unshift @dirnames, $parent;
     }
-    for (@dirnames) {
-        next if (-d $_);
+    for my $dir (@dirnames) {
+        next if (-d $dir);
         $! = 0; # clear
-        mkdir $_, $mode;
+        mkdir $dir, $mode;
         if ($!) {
-            return ('error_creating_directory', $_, $!);
+            return ('error_creating_directory', $dir, $!);
         }
-        chown $uid, $gid, $_;
+        chown $uid, $gid, $dir;
         if ($!) {
-            return ('error_chowning_directory', $_, $!);
+            return ('error_chowning_directory', $dir, $!);
         }
-        chmod $mode, $_;
+        chmod $mode, $dir;
         $mode_string = sprintf "%lo", $mode;
-        debug(1, "makePaths: created directory $_ mode $mode_string user $user group $group\n");
-        debug(2, "\t" . `ls -ld $_`);
+        debug(1, "makePaths: created directory $dir mode $mode_string user $user group $group\n");
+        debug(2, "\t" . `ls -ld $dir`);
     }
 
     return ();
@@ -926,9 +926,10 @@ sub remove_pidfile
     unless(open(INFILE,"$instdir/start-slapd")) {
         print("Cannot open start-slapd file for reading "); return 0;
     }
-    while(<INFILE>) {
-        if (/start-dirsrv /g) {
-            my @servline=split(/start-dirsrv /, );
+    my $line;
+    while($line = <INFILE>) {
+        if ($line =~ /start-dirsrv /g) {
+            my @servline=split(/start-dirsrv /, $line);
             @servline=split(/\s+/, $servline[1]);
             $serv_id=$servline[0];
         }
@@ -939,14 +940,14 @@ sub remove_pidfile
     unless(open(INFILE,"@initconfigdir@/@package_name@-$serv_id")) {
         print("Couldn't open @initconfigdir@/@package_name@-$serv_id "); return 0;
     }
-    while(<INFILE>) {
-        if (/RUN_DIR=/g) {
-            my @rundir_line=split(/RUN_DIR=+/, );
+    while($line = <INFILE>) {
+        if ($line =~ /RUN_DIR=/g) {
+            my @rundir_line=split(/RUN_DIR=+/, $line);
             @rundir_line=split(/;/, $rundir_line[1]);
             $run_dir = $rundir_line[0];
             chop($run_dir);
-        } elsif (/PRODUCT_NAME=/g) {
-            my @product_line=split(/PRODUCT_NAME=+/, );
+        } elsif ($line =~ /PRODUCT_NAME=/g) {
+            my @product_line=split(/PRODUCT_NAME=+/, $line);
             @product_line=split(/;/, $product_line[1]);
             $product_name = $product_line[0];
             chop($product_name);
diff --git a/ldap/admin/src/scripts/dnaplugindepends.ldif b/ldap/admin/src/scripts/dnaplugindepends.ldif
new file mode 100644
index 0000000..9622c42
--- /dev/null
+++ b/ldap/admin/src/scripts/dnaplugindepends.ldif
@@ -0,0 +1,4 @@
+dn: cn=Distributed Numeric Assignment Plugin,cn=plugins,cn=config
+changetype: modify
+add: nsslapd-plugin-depends-on-type
+nsslapd-plugin-depends-on-type: database
diff --git a/ldap/admin/src/scripts/dsupdate.map.in b/ldap/admin/src/scripts/dsupdate.map.in
new file mode 100644
index 0000000..a1c0633
--- /dev/null
+++ b/ldap/admin/src/scripts/dsupdate.map.in
@@ -0,0 +1,65 @@
+# BEGIN COPYRIGHT BLOCK
+# This Program is free software; you can redistribute it and/or modify it under
+# the terms of the GNU General Public License as published by the Free Software
+# Foundation; version 2 of the License.
+#
+# This Program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+# FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this Program; if not, write to the Free Software Foundation, Inc., 59 Temple
+# Place, Suite 330, Boston, MA 02111-1307 USA.
+#
+# In addition, as a special exception, Red Hat, Inc. gives You the additional
+# right to link the code of this Program with code not covered under the GNU
+# General Public License ("Non-GPL Code") and to distribute linked combinations
+# including the two, subject to the limitations in this paragraph. Non-GPL Code
+# permitted under this exception must only link to the code of this Program
+# through those well defined interfaces identified in the file named EXCEPTION
+# found in the source code files (the "Approved Interfaces"). The files of
+# Non-GPL Code may instantiate templates or use macros or inline functions from
+# the Approved Interfaces without causing the resulting work to be covered by
+# the GNU General Public License. Only Red Hat, Inc. may make changes or
+# additions to the list of Approved Interfaces. You must obey the GNU General
+# Public License in all respects for all of the Program code and other code used
+# in conjunction with the Program except the Non-GPL Code covered by this
+# exception. If you modify this file, you may extend this exception to your
+# version of the file, but you are not obligated to do so. If you do not wish to
+# provide this exception without modification, you must delete this exception
+# statement from your version and license this file solely under the GPL without
+# exception.
+#
+#
+# Copyright (C) 2007 Red Hat, Inc.
+# All rights reserved.
+# END COPYRIGHT BLOCK
+#
+# [Parameter resolution rules]
+# * If the right-hand value is in ` (backquote), the value is eval'ed by perl.
+#   The output should be stored in $returnvalue to pass to the internal hash.
+# * If the right-hand value is in " (doublequote), the value is passed as is.
+# * If the right-hand value is not in any quote, the value should be found
+#   in either of the setup inf file (static) or the install inf file (dynamic).
+# * Variables surrounded by @ (e.g., @configdir@) are replaced with the 
+#   system path at the compile time.
+# * The right-hand value can contain variables surrounded by % (e.g., %asid%)
+#   which refers the right-hand value (key) of this map file.
+# 
+fqdn =			FullMachineName
+dsid =			ServerIdentifier
+ds_user =		SuiteSpotUserID
+ds_port =		ServerPort
+rootdn =		RootDN
+
+schema_dir =    schema_dir
+lock_dir =      lock_dir
+tmp_dir =       tmp_dir
+cert_dir =      cert_dir
+ldif_dir =      ldif_dir
+bak_dir =       bak_dir
+inst_dir =      inst_dir
+log_dir =       log_dir
+config_dir =    config_dir
+db_dir =        db_dir
+run_dir =       run_dir
diff --git a/ldap/admin/src/scripts/exampleupdate.ldif b/ldap/admin/src/scripts/exampleupdate.ldif
new file mode 100644
index 0000000..00f9a70
--- /dev/null
+++ b/ldap/admin/src/scripts/exampleupdate.ldif
@@ -0,0 +1,40 @@
+# BEGIN COPYRIGHT BLOCK
+# This Program is free software; you can redistribute it and/or modify it under
+# the terms of the GNU General Public License as published by the Free Software
+# Foundation; version 2 of the License.
+# 
+# This Program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+# FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
+# 
+# You should have received a copy of the GNU General Public License along with
+# this Program; if not, write to the Free Software Foundation, Inc., 59 Temple
+# Place, Suite 330, Boston, MA 02111-1307 USA.
+# 
+# In addition, as a special exception, Red Hat, Inc. gives You the additional
+# right to link the code of this Program with code not covered under the GNU
+# General Public License ("Non-GPL Code") and to distribute linked combinations
+# including the two, subject to the limitations in this paragraph. Non-GPL Code
+# permitted under this exception must only link to the code of this Program
+# through those well defined interfaces identified in the file named EXCEPTION
+# found in the source code files (the "Approved Interfaces"). The files of
+# Non-GPL Code may instantiate templates or use macros or inline functions from
+# the Approved Interfaces without causing the resulting work to be covered by
+# the GNU General Public License. Only Red Hat, Inc. may make changes or
+# additions to the list of Approved Interfaces. You must obey the GNU General
+# Public License in all respects for all of the Program code and other code used
+# in conjunction with the Program except the Non-GPL Code covered by this
+# exception. If you modify this file, you may extend this exception to your
+# version of the file, but you are not obligated to do so. If you do not wish to
+# provide this exception without modification, you must delete this exception
+# statement from your version and license this file solely under the GPL without
+# exception. 
+# 
+# 
+# Copyright (C) 2009 Red Hat, Inc.
+# All rights reserved.
+# END COPYRIGHT BLOCK
+#
+
+# These files work the same way as the LDIF templates in
+# /usr/share/dirsrv/ldif/template*.ldif
diff --git a/ldap/admin/src/scripts/exampleupdate.pl b/ldap/admin/src/scripts/exampleupdate.pl
new file mode 100644
index 0000000..cff4a3d
--- /dev/null
+++ b/ldap/admin/src/scripts/exampleupdate.pl
@@ -0,0 +1,56 @@
+# BEGIN COPYRIGHT BLOCK
+# This Program is free software; you can redistribute it and/or modify it under
+# the terms of the GNU General Public License as published by the Free Software
+# Foundation; version 2 of the License.
+# 
+# This Program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+# FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
+# 
+# You should have received a copy of the GNU General Public License along with
+# this Program; if not, write to the Free Software Foundation, Inc., 59 Temple
+# Place, Suite 330, Boston, MA 02111-1307 USA.
+# 
+# In addition, as a special exception, Red Hat, Inc. gives You the additional
+# right to link the code of this Program with code not covered under the GNU
+# General Public License ("Non-GPL Code") and to distribute linked combinations
+# including the two, subject to the limitations in this paragraph. Non-GPL Code
+# permitted under this exception must only link to the code of this Program
+# through those well defined interfaces identified in the file named EXCEPTION
+# found in the source code files (the "Approved Interfaces"). The files of
+# Non-GPL Code may instantiate templates or use macros or inline functions from
+# the Approved Interfaces without causing the resulting work to be covered by
+# the GNU General Public License. Only Red Hat, Inc. may make changes or
+# additions to the list of Approved Interfaces. You must obey the GNU General
+# Public License in all respects for all of the Program code and other code used
+# in conjunction with the Program except the Non-GPL Code covered by this
+# exception. If you modify this file, you may extend this exception to your
+# version of the file, but you are not obligated to do so. If you do not wish to
+# provide this exception without modification, you must delete this exception
+# statement from your version and license this file solely under the GPL without
+# exception. 
+# 
+# 
+# Copyright (C) 2009 Red Hat, Inc.
+# All rights reserved.
+# END COPYRIGHT BLOCK
+#
+
+sub pre {
+    my ($inf, $configdir) = @_;
+}
+
+sub preinst {
+    my ($inf, $inst, $dseldif, $conn) = @_;
+}
+sub runinst {
+    my ($inf, $inst, $dseldif, $conn) = @_;
+}
+
+sub postinst {
+    my ($inf, $inst, $dseldif, $conn) = @_;
+}
+
+sub post {
+    my ($inf, $configdir) = @_;
+}
diff --git a/ldap/admin/src/scripts/exampleupdate.sh b/ldap/admin/src/scripts/exampleupdate.sh
new file mode 100644
index 0000000..dae2e4c
--- /dev/null
+++ b/ldap/admin/src/scripts/exampleupdate.sh
@@ -0,0 +1,63 @@
+#!/bin/sh
+# BEGIN COPYRIGHT BLOCK
+# This Program is free software; you can redistribute it and/or modify it under
+# the terms of the GNU General Public License as published by the Free Software
+# Foundation; version 2 of the License.
+# 
+# This Program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+# FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
+# 
+# You should have received a copy of the GNU General Public License along with
+# this Program; if not, write to the Free Software Foundation, Inc., 59 Temple
+# Place, Suite 330, Boston, MA 02111-1307 USA.
+# 
+# In addition, as a special exception, Red Hat, Inc. gives You the additional
+# right to link the code of this Program with code not covered under the GNU
+# General Public License ("Non-GPL Code") and to distribute linked combinations
+# including the two, subject to the limitations in this paragraph. Non-GPL Code
+# permitted under this exception must only link to the code of this Program
+# through those well defined interfaces identified in the file named EXCEPTION
+# found in the source code files (the "Approved Interfaces"). The files of
+# Non-GPL Code may instantiate templates or use macros or inline functions from
+# the Approved Interfaces without causing the resulting work to be covered by
+# the GNU General Public License. Only Red Hat, Inc. may make changes or
+# additions to the list of Approved Interfaces. You must obey the GNU General
+# Public License in all respects for all of the Program code and other code used
+# in conjunction with the Program except the Non-GPL Code covered by this
+# exception. If you modify this file, you may extend this exception to your
+# version of the file, but you are not obligated to do so. If you do not wish to
+# provide this exception without modification, you must delete this exception
+# statement from your version and license this file solely under the GPL without
+# exception. 
+# 
+# 
+# Copyright (C) 2009 Red Hat, Inc.
+# All rights reserved.
+# END COPYRIGHT BLOCK
+#
+
+# There are several environment variables passed in:
+my $PRE_STAGE = "pre";
+my $PREINST_STAGE = "preinst";
+my $RUNINST_STAGE = "runinst";
+my $POSTINST_STAGE = "postinst";
+my $POST_STAGE = "post";
+
+# $DS_UPDATE_STAGE - the current stage of the update - one of
+# pre - called at the beginning of the update
+# preinst - called before processing an instance
+# runinst - the main update stage for an instance
+# postinst - called after processing an instance
+# post - called the the end of the update
+# you should definitely check the stage to make sure you only perform
+# your actions during the correct stage e.g.
+
+if [ "$DS_UPDATE_STAGE" != "pre" ] ; then
+    exit 0
+fi
+
+# $DS_UPDATE_DIR - the main config directory containing the schema dir
+#   the config dir and the instance specific (slapd-instance) directories
+# $DS_UPDATE_INST - the name of the instance (slapd-instance), if one of the instance specific stages
+# $DS_UPDATE_DSELDIF - the full path ane filename of the dse.ldif file for the instance
diff --git a/ldap/admin/src/scripts/migrate-ds.res b/ldap/admin/src/scripts/migrate-ds.res
index 3d01f0f..d58649b 100644
--- a/ldap/admin/src/scripts/migrate-ds.res
+++ b/ldap/admin/src/scripts/migrate-ds.res
@@ -9,7 +9,6 @@ error_reading_olddbconfig = Could not read the old database configuration inform
 error_migrating_schema = Could not copy old schema file '%s'.  Error: %s\n
 error_opening_schema = Could not open new schema file '%s'.  Error: %s\n
 error_schema_permissions = Could not reset permissions on schema file '%s'.  Error: %s\n
-error_renaming_schema = Could not rename schema file '%s' tp '%s'.  Error: %s\n
 error_copying_dbdir = Could not copy database directory '%s' to '%s'.  Error: %s\n
 error_copying_dbfile = Could not copy database file '%s' to '%s'.  Error: %s\n
 error_dbsrcdir_not_exist = Could not copy from the database source directory '%s' because it does not exist.  Please check your configuration.\n
diff --git a/ldap/admin/src/scripts/setup-ds.pl.in b/ldap/admin/src/scripts/setup-ds.pl.in
index 7fdc977..aad6bfc 100644
--- a/ldap/admin/src/scripts/setup-ds.pl.in
+++ b/ldap/admin/src/scripts/setup-ds.pl.in
@@ -48,6 +48,7 @@ use Resource;
 use DialogManager;
 use Util;
 use DSCreate;
+use DSUpdate;
 
 my $res = new Resource("@propertydir@/setup-ds.res");
 
@@ -56,11 +57,16 @@ my $setup = new Setup($res);
 if (!$setup->{silent}) {
     my $dialogmgr = new DialogManager($setup, $res, $TYPICAL);
 
-    require SetupDialogs;
-    require DSDialogs;
-
-    my @dialogs = SetupDialogs->getDialogs();
-    push @dialogs, DSDialogs->getDialogs();
+    my @dialogs;
+    if ($setup->{update}) {
+        require DSUpdateDialogs;
+        push @dialogs, DSUpdateDialogs->getDialogs();
+    } else {
+        require SetupDialogs;
+        require DSDialogs;
+        push @dialogs, SetupDialogs->getDialogs();
+        push @dialogs, DSDialogs->getDialogs();
+    }
 
     $dialogmgr->addDialog(@dialogs);
 
@@ -71,15 +77,29 @@ if (!$setup->{silent}) {
     $setup->{inf}->write();
 }
 
-my @errs = createDSInstance($setup->{inf});
+my @errs;
+if ($setup->{update}) {
+    @errs = updateDS($setup);
+} else {
+    @errs = createDSInstance($setup->{inf});
+}
+
 if (@errs) {
     $setup->msg(@errs);
-    $setup->msg($FATAL, 'error_creating_dsinstance',
-                $setup->{inf}->{slapd}->{ServerIdentifier});
+    if ($setup->{update}) {
+        $setup->msg($FATAL, 'error_updating');
+    } else {
+        $setup->msg($FATAL, 'error_creating_dsinstance',
+                    $setup->{inf}->{slapd}->{ServerIdentifier});
+    }
     $setup->doExit(1);
 } else {
-    $setup->msg('created_dsinstance',
-                $setup->{inf}->{slapd}->{ServerIdentifier});
+    if ($setup->{update}) {
+        $setup->msg('update_successful');
+    } else {
+        $setup->msg('created_dsinstance',
+                    $setup->{inf}->{slapd}->{ServerIdentifier});
+    }
 }
 
 $setup->doExit(0);
@@ -91,3 +111,10 @@ END {
         }
     }
 }
+
+# emacs settings
+# Local Variables:
+# mode:perl
+# indent-tabs-mode: nil
+# tab-width: 4
+# End:
diff --git a/ldap/admin/src/scripts/setup-ds.res.in b/ldap/admin/src/scripts/setup-ds.res.in
index 5326963..c4be658 100644
--- a/ldap/admin/src/scripts/setup-ds.res.in
+++ b/ldap/admin/src/scripts/setup-ds.res.in
@@ -136,3 +136,48 @@ error_no_such_instance = Error: could not find directory server configuration di
 error_finding_config_entry = Error: could not find the config entry '%s' in '%s'.  Error: %s\n
 error_removing_path = Error: could not remove path '%s'.  Error: %s\n
 error_removing_port_label = Error: could not remove selinux label from port '%s'.  Error: %s\n
+error_loading_update = Error: not applying update '%s'.  Error: %s\n
+error_unknown_update = Error: cannot apply update '%s'.  Not a recognized update type.\n
+error_executing_update = Error: update '%s' returned code '%s': %s\n
+error_updating = Error: could not update the directory server.\n
+update_successful = Finished successful update of directory server.\n
+
+update_dialog_first = This program will update the %s Directory Server.\n\nIt is recommended that you have "root" privilege to perform the update.\nTips for using this  program:\n  - Press "Enter" to choose the default and go to the next screen\n  - Type "Control-B" or the word "back" then "Enter" to go back to the previous screen\n  - Type "Control-C" to cancel the update\n\n
+# %s -> brand
+
+update_dialog_first_prompt = Would you like to continue with update?
+
+update_dialog_mode =\
+The update process can work in one of two modes:\
+\
+  - Online: The changes are made to the running directory servers using LDAP.\
+            The operations must be performed as an administrative user.\
+            You must provide the name and password, for each instance\
+            if there is more than one instance of directory server.\
+            Some operations may require a directory server restart to take\
+            effect.  The update script will notify you if you need to restart\
+            the server.\
+\
+  - Offline: The changes are made to the server configuration files.  The\
+             servers MUST FIRST BE SHUTDOWN BY YOU.  The script will not\
+             shutdown the servers for you.  You MUST shutdown the\
+             servers in order to use this mode.  A username and password\
+             are not required to use Offline mode.  If the servers are not\
+             shutdown, CHANGES WILL BE LOST.\
+\
+To summarize:\
+  Online - servers remain running - you must provide admin name and password\
+           for each server - servers may need to be restarted\
+  Offline - servers must be shutdown - no username or password required\n\n
+
+update_dialog_mode_prompt = Which update mode do you want to use?
+
+update_admin_dialog = Please specify the authentication data for '%s'\n\n
+update_admin_id_prompt = Full DN of administrative user
+update_admin_pwd_prompt = Password for this user
+error_renaming_schema = Could not rename schema file '%s' tp '%s'.  Error: %s\n
+error_reading_schema_dir = Schema directory '%s' does not exist or is not readable\n
+error_online_update = Could not open a connection to the server at %s port %s as '%s'.\
+Please make sure the server is up and running before using online mode,\
+or use offline mode.\n\n
+error_offline_update = Could not read the server config file '%s'. Error: %s\n\n
diff --git a/ldap/ldif/template-pampta.ldif.in b/ldap/ldif/template-pampta.ldif.in
index 2875df7..10df352 100644
--- a/ldap/ldif/template-pampta.ldif.in
+++ b/ldap/ldif/template-pampta.ldif.in
@@ -17,4 +17,8 @@ pamIDAttr: notUsedWithRDNMethod
 pamFallback: FALSE
 pamSecure: TRUE
 pamService: ldapserver
-
+# these will be replaced when the server loads the plugin
+nsslapd-pluginId: ID
+nsslapd-pluginVersion: PACKAGE_VERSION
+nsslapd-pluginVendor: VENDOR
+nsslapd-pluginDescription: DESC
-- 
1.5.5.6

